/*
   Modul: M_WINDOW (Headerdatei)

   geschrieben von Thomas Knneth
   Friedrich-Neuper-Str. 2b
   90552 Rthenbach

   Diese Datei ist Bestandteil der C-Version von Magic 4.0 von
   Peter Hellinger und Thomas Knneth und darf nur gem den
   Nutzungsbedingungen von Magic fr C verwendet werden

   Alle Rechte beim Autor
*/

#ifndef _MPWINDOW_
#define _MPWINDOW_

#ifndef _MAGICTYP_
#include <magic\m_types.h>
#endif

#define  wDefault                0L   /* Nix weiter tun                       */
#define  wBell                   1L   /* Kling Glckchen klingelingeling      */
#define  wColor                  2L   /* Hintergrundfarbe des Fensters ndern */
#define  wFulled                 4L   /* Fenster auf volle Gre bringen      */
#define  wTopped                 8L   /* Fenster toppen                       */
#define  wHSlide                16L   /* Horizontal-Slider setzen             */
#define  wVSlide                32L   /* Vertikal-Slider setzen               */
#define  wSized                 64L   /* Fenstergre ndern                  */
#define  wMoved                128L   /* Fensterposition ndern               */
#define  wSizePos              256L   /* Fenster auf Gre + Position bringen */
#define  wChangeFont           512L   /* Font ndern                          */
#define  wClose               1024L   /* Fenster schliessen                   */
#define  wBottom              2048L
#define  wIconify             4096L
#define  wAllIconify          8192L
#define  wUniconify          16384L
#define  wHSUpdate           32768L
#define  wVSUpdate           65536L
#define  wCallback          131072L
#define  wTempClose         262144L
#define  wReopen            524288L
#define  wSetAsterik       1048576L
#define  wDelAsterik       2097152L

#define  VSlider      0
#define  HSlider      1

typedef int tExData[16];

typedef struct _WinParameter
{
   int         window,
               mx,
               my,
               message;
   GRECT       spec;
   tExData     extended;
   LONGBITSET  action;
   void        *res;
   /* Ab Lib-Version $407 */
   OBJECT      *tree;
} WinParameter;

#define  WinMenu            1
#define  WinText            2
#define  WinDial            4
#define  WinDrag            8
#define  WinMaxsize        16
#define  WinArrows         32
#define  WinTopAllowed     64
#define  WinMultiRsc    32768

typedef WinParameter* PtrWinPara;

typedef struct _WinResource
{
	OBJECT		*tree;
	int			xpos,
				ypos,
				mode,
				res1;
	void		*res2;
} WinResource;

#define  MaxResource  16
#define  tbUp          0
#define  tbDown        1
#define  tbLeft        2
#define  tbRight       3

typedef WinResource WinTreeList[MaxResource];

/* Definition eines Funktionstyps */
typedef  void  (*RewriteProc)(void);
typedef  void  (*WindowHandler)(PtrWinPara);

BOOLEAN RectList(int win,int flag,GRECT *rect);
BOOLEAN RcIntersect(GRECT *rc1,GRECT *rc2);
void RedrawObjc(int win,OBJECT *tree,int entry,int depth,GRECT *clip);
void RedrawWindow(int win,int entry,int depth,GRECT *clip);
int OpenWindow (WindowHandler handler,
                BITSET element,BITSET extended,
                int backcolor,int backrast,
                int x,int y,int w,int h,int xo,int yo,int wo,int ho,
                const char *name,const char *info,
                void *rsc,void *exinfo);
void CloseWindow(int win);
int DisposeWindows(void);
void SetWinName(int win,const char *name);
void SetWinInfo(int win,const char *info);
char *WinName(int win);
char *WinInfo(int win);
void SetWinAsterik(int win);
void DelWinAsterik(int win);
void SetWinTop(int win);
void SetWinBottom(int win);
void SetWinFull(int win);
void SetWinRect(int win, GRECT *rect);
void SetWinColor(int win,int color,int back);
void SetWinPos(int win,int xx,int yy);
void SetWinSize(int win,int ww,int hh);
void GetWinRect(int win,GRECT *rect);
void GetWorkRect(int win,GRECT *rect);
void GetUseableRect(int win,GRECT *rect);
void SetWinSlider(int win,int which,int pos,int size);
void PreventTopping (BOOLEAN prevent);
OBJECT *GetObjctree(int win);
OBJECT *GetMenutree(int win);
void RewriteWindow(int win,int handle,RewriteProc prc);
void *GetWinExinfo(int win);
void GEMTop(int *win,BOOLEAN *own);
BOOLEAN WinIconified(int win);
void IconifyWindow(int win,GRECT *rect,BOOLEAN iconify);
void SetIcontext(int win,const char *text);
void SetWinIcon(int win,CICONBLK *icon);
void TempCloseWin(int win);
void ReopenWin(int win);
void SendSpecMessage(int win,int winmsg,int mx,int my,GRECT *r,tExData ex);
BOOLEAN WinOpen(int win);
int WinTop(BOOLEAN nodials);

#define RedrawScreen() CallMagic(2404)
#define TopNext()      CallMagic(2413)

#endif
